const crypto = require('crypto');
const fs = require("fs");
const http = require("http");
const https = require("https");
// const log = require('./src/modules/helper/log.js');;


/* ------------- [START STORE CONFIG] ------------ */
process.env.NODE_ENV = process.env.NODE_ENV || 'development';
const config = require('./src/config/config').get(process.env.NODE_ENV);

/* ------------- [END STORE CONFIG] ------------ */
/* ------------- [START IMPORT OUR MODULE] ------------ */
const logger = require('./src/logger/logger');
const express = require('./src/config/express');
var app = express();
/* ------------- [END IMPORT OUR MODULE] ------------ */

/* ------------- [END IMPORT SSL CONFIG] ------------ */
/* ------------- [START INITIAL OUR APPLICATION] ------------ */
if ( (config.app_https === 'true' ) ) {
  /* ------------- [START IMPORT SSL CONFIG] ------------ */
  const privateKey = fs.readFileSync(config.KEY);
  const certificate = fs.readFileSync(config.CERT);
  
  const options = {
    key: privateKey,
    cert: certificate
  };
  options.rejectUnauthorized = false ; 
  https.createServer(options, app).listen(config.app_port);
  logger.info(`Is Secure : | Port : ${config.app_port}`);
} else {
  http.createServer(app).listen(config.app_port);
  logger.info(`Isn't Secure : | Port : ${config.app_port}`);
}
logger.info("ENVIRONMENT : "+ process.env.NODE_ENV);
// logger.info("App Port: "+config.app_port);
/* ------------- [END INITIAL OUR APPLICATION] ------------ */

module.exports = app;
