module.exports = Object.freeze({
    REQUEST: 'Request',
    RESPONSE: 'Response',
    SUCCESS: 'Success',
    ERROR: 'Error',
    FAIL: 'Fail',
    METHOD:{
        GET : 'GET',
        POST : 'POST',
        PUT : 'PUT',
        DELETE : 'DELETE'
    },
    RESPONSECONN:{
        STATS:{
            ETIMEDOUT:'ETIMEDOUT',
            ECONNREFUSED : 'ECONNREFUSED',
            ESOCKETTIMEDOUT : 'ESOCKETTIMEDOUT',
            MISSING : 'Missing'
        },
        MESSAGE:{
            ETIMEDOUT:{
                resultCode : '50003',
                resultDescription : 'Timeout'
            },
            ECONNREFUSED:{
                resultCode : '50002',
                resultDescription : 'Reject'
            },
            ESOCKETTIMEDOUT:{
                resultCode : '50003',
                resultDescription : 'Timeout'
            },
            ERROR:{
                resultCode : '50000',
                resultDescription : 'System error'
            },
            SUCCESS:{
                resultCode : '20000',
                resultDescription : 'Success'
            },
            EXCEED:{
                resultCode : '40302',
                resultDescription : 'Exceed data allowances'
            }
        }
    },
    RESPONSERESULT:{
        SUCCESS:{
            resultCode : '20000',
            developerMessage : 'Success'
        },
        MISSING_INVALID:{
            resultCode : '40300',
            developerMessage : 'Missing or invalid parameter'
        },
        DATA_NOT_FOUND:{
            resultCode : '40401',
            developerMessage : 'Data Not Found'
        },
        DATA_EXIST:{
            resultCode : '40301',
            developerMessage : 'Data Exist'
        },
        ERROR:{
            resultCode : '50000',
            developerMessage : 'System error'
        },
        UNKNOW:{
            resultCode : '40400',
            developerMessage : 'Unknown URL'
        }
    }
});