var stats = require('../helper/stats.js'); 
var constants = require('../helper/constants.js');
var responseMsg = [];


responseMsg.error = function (req,cmd,code){
    
    // var devMsg = "System error";
    var response;
    switch(code) {
        case 40300:
            response = constants.RESPONSERESULT.MISSING_INVALID
            break;
        case 40401:
            response = constants.RESPONSERESULT.DATA_NOT_FOUND
            break;
        case 40301:
            response = constants.RESPONSERESULT.DATA_EXIST
            break;
        case 50000:
            response = constants.RESPONSERESULT.ERROR;
            break;
        default:
            response = constants.RESPONSERESULT.ERROR;
    }


    stats.sendResponse(req.method,cmd,constants.ERROR);
    return response;
};

responseMsg.success = function (req,cmd,data){
    
    var response = {
        resultCode : constants.RESPONSERESULT.SUCCESS.resultCode,
        developerMessage : constants.RESPONSERESULT.SUCCESS.developerMessage,
        resultData : data.resultData,
        rowCount : data.resultData.length
    };

    stats.sendResponse(req.method,cmd,constants.SUCCESS);
    return response;
};

responseMsg.direct = function (req,cmd,result,data)
{
    var response = {
        resultCode : result.resultCode,
        developerMessage : result.resultDescription
    };

    if(result.resultCode == constants.RESPONSERESULT.SUCCESS.resultCode)
    {
        stats.sendResponse(req.method,cmd,constants.SUCCESS);
        if(data)
            response = Object.assign(response,data);
    }
    else
        stats.sendResponse(req.method,cmd,constants.ERROR);
    
    return response;
};

responseMsg.unknow = function (req)
{
    var response = constants.RESPONSERESULT.UNKNOW;
    stats.receiveUnknow(response.developerMessage);
    stats.sendUnknow(response.developerMessage);
    return response;
};

module.exports = responseMsg;