var env = process.env.NODE_ENV || 'development'; 
var cfg = require('../../config/config.js').get(env);
var log = require('../helper/log.js');
var constants = require('../helper/constants.js');

var nodeName = cfg.app_name;
var stat = [];

// CMF => SACF
stat.sendSACFRequest = function (toNode,cmd){
    writeStats(nodeName+" Send "+toNode+" OutRedirect SPW_"+cmd+" Request");
};

stat.receiveSACFResponse = function (fromNode,cmd,result){
    writeStats(nodeName+" Receive "+fromNode+" OutRedirect SPW_"+cmd+" Response "+result);
};

stat.receiveSACFBadResponse = function (fromNode,cmd){
    writeStats(nodeName+" Receive "+fromNode+" Bad OutRedirect SPW_"+cmd+" Response");
};

//client => CMF
stat.receiveRequest = function (method,cmd){
    writeStats(nodeName+" Receive "+method+" "+cmd+" Request");
};

stat.receiveBadRequest = function (method,cmd){
    writeStats(nodeName+" Receive Bad "+method+" "+cmd+" Request");
};

stat.sendResponse = function (method,cmd,result){
    writeStats(nodeName+" Send "+method+" "+cmd+" Response "+result);
};

//CMF => other server [in REST api]
stat.sendRestRequest = function (toNode,method,cmd){
    writeStats(nodeName+" Send "+toNode+" "+method+" "+cmd+" Request");
};

stat.receiveRestResponse = function (fromNode,method,cmd,result){
    writeStats(nodeName+" Receive "+fromNode+" "+method+" "+cmd+" Response "+result);
};

stat.receiveBadRestResponse = function (fromNode,method,cmd){
    writeStats(nodeName+" Receive "+fromNode+" Bad "+method+" "+cmd+" Response");
};

//CMF => other server
stat.sendRequest = function (toNode,cmd){
    writeStats(nodeName+" Send "+toNode+" "+cmd+" Request");
};

stat.receiveResponse = function (fromNode,cmd,result){
    writeStats(nodeName+" Receive "+fromNode+" "+cmd+" Response "+result);
};

stat.receiveBadResponse = function (fromNode,cmd,result){
    writeStats(nodeName+" Receive "+fromNode+" Bad "+cmd+" Response ");
};

//unknow
// CMF Receive Unknown URL Request
// CMF Send Unknown URL
stat.receiveUnknow = function(message){
    writeStats(nodeName+" Receive "+message+" "+constants.REQUEST);
};

stat.sendUnknow = function(message){
    writeStats(nodeName+" Send "+message);
};

function writeStats(string) {
    log.log(string);
    log.stat(string);
    // console.log(string);
    // console.log(cfg);
}

module.exports = stat;